<script lang="ts">
	import clsx from "clsx"
	import { fade } from "svelte/transition"
	import SidebarNavItem from "./SidebarNavItem.svelte"
	import { page } from "$app/stores"

	let open = false

	export function close() {
		open = false
	}

	function autoclose(element: Element) {
		// Close after clicking on a link
		function handleClick(event) {
			if (event.target.closest("a")) {
				close()
			}
		}
		element.addEventListener("click", handleClick)
		return {
			destroy() {
				document.removeEventListener("click", handleClick)
			},
		}
	}
</script>

<section class="min-h-screen bg-gray-50" use:autoclose>
	<nav
		class={clsx(
			"fixed top-0 left-0 z-20 h-full pb-10 overflow-x-hidden overflow-y-auto transition origin-left transform bg-white border-r w-60 md:translate-x-0",
			open ? "translate-x-0" : "-translate-x-full"
		)}
	>
		<a href="/" class="flex items-center px-4 py-5">Git DMS</a>
		<nav class="text-sm font-medium text-gray-600" aria-label="Main Navigation">
			<slot name="nav">
				<SidebarNavItem active={$page.path === "/"} href="/">Home</SidebarNavItem>
			</slot>
		</nav>
	</nav>
	<div class="ml-0 transition md:ml-60">
		<header class="flex items-center w-full px-4 bg-white border-b h-14">
			<button class="block btn btn-light md:hidden" on:click|stopPropagation={() => (open = true)}>
				<span class="sr-only">Menu</span>
				<svg class="w-4 h-4" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor">
					<path
						fill-rule="evenodd"
						d="M3 5a1 1 0 011-1h12a1 1 0 110 2H4a1 1 0 01-1-1zM3 10a1 1 0 011-1h12a1 1 0 110 2H4a1 1 0 01-1-1zM3 15a1 1 0 011-1h12a1 1 0 110 2H4a1 1 0 01-1-1z"
						clip-rule="evenodd"
					/>
				</svg>
			</button>
			<div class="flex items-center ml-auto">
				<slot name="header-right" />
			</div>
		</header>
		<div class="p-4 prose max-w-none">
			<slot />
		</div>
	</div>
	<!-- Sidebar Backdrop -->
	{#if open}
		<div
			class="fixed inset-0 z-10 w-screen h-screen bg-black bg-opacity-25 md:hidden"
			transition:fade
			on:click={() => close()}
		/>
	{/if}
</section>
